#include <queue>
#include <iostream>
#include <vector>

struct Station {
    Station():dist(-1){}
    int dist;
    std::vector<int> children;
};
std::vector<Station> stations;
std::vector<bool> isSource;
std::vector<bool> isCollector;
int source = 0, collector = 0;
bool found = false;
int nMarked = 0;
unsigned N, M;

int count_pipes(const int st, const unsigned nodes) {
    std::cout << "st" << st + 1<< std::endl;
    if (st == collector) {
        found = (nodes == N - 1);
        return -1;
    }
    
    if (stations[st].dist != -1)
        return stations[st].dist;

    for (auto child : stations[st].children) {
        int dist = count_pipes(child, nodes + 1) - nodes;
        if (dist > stations[st].dist){
            stations[st].dist = dist;
            std::cout << st << 'd' << dist << std::endl;
            }
    }

    return stations[st].dist + nodes;
}

int main() {
    std::cin >> N >> M;
    for (unsigned i = 0; i < N; i++)
        stations.push_back(Station());
    for (unsigned i = 0; i < N; i++) {
        isSource.push_back(true);
        isCollector.push_back(true);
    }
    
    for (unsigned i = 0; i < M; i++) {
        int s, t;
        std::cin >> s >> t;
        s--;
        t--;
        stations[s].children.push_back(t);
        isSource[t] = false;
        while (!isSource[source]) 
            source++;
        isCollector[s] = false;
        while(!isCollector[collector])
            collector++;
    }
    int result = count_pipes(source, 0);
    std::cout << found << std::endl;
    std::cout << (found ? (M - result) : 0) << std::endl;
    return 0;
}

/*
5 6
2 4
3 5
2 5
1 4
2 3
5 1
*/

/*
4 4
1 2
1 3
2 4
3 4
*/

/*
5 5
1 2
1 3
2 4
3 4
4 5
*/
